/*
 * lilJudd
 * Copyright (C) 2023 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.lilJudd.util

import dev.kord.common.entity.ButtonStyle
import dev.kord.core.entity.Embed
import dev.kord.rest.builder.component.ActionRowBuilder
import dev.kord.rest.builder.message.EmbedBuilder

object ButtonUtil {
    fun getTimePlannerButtons(): ActionRowBuilder {
        val ar = ActionRowBuilder()
        ar.interactionButton(ButtonStyle.Success, "public.edit.btn.timemanagement.available") {
            this.label = "Available"
        }
        ar.interactionButton(ButtonStyle.Primary, "public.edit.btn.timemanagement.maybeavailable") {
            this.label = "Maybe available"
        }
        ar.interactionButton(ButtonStyle.Danger, "public.edit.btn.timemanagement.notavailable") {
            this.label = "Not available"
        }
        return ar
    }

    fun replaceXWithYinValuesAtTable(x: String, y: String, e: Embed, table: Int): EmbedBuilder {
        val ebb = MessageUtil.getAClonedEmbedd(e)
        for ((i, f) in e.fields.withIndex()) {
            val fb = EmbedBuilder.Field()
            fb.name = f.name
            if (i == table - 1) {
                val v = f.value.split("\n").toMutableList()
                for ((i, l) in v.withIndex())
                    if (l.contains(x))
                        v[i] = "\n${y}"
                fb.value = v.joinToString("\n")
            } else
                fb.value = f.value
            fb.inline = true
            ebb.fields.add(fb)
        }
        return ebb
    }

    fun addXToValuesAtTable(x: String, e: Embed, table: Int): EmbedBuilder {
        val ebb = MessageUtil.getAClonedEmbedd(e)
        for ((i, f) in e.fields.withIndex()) {
            val fb = EmbedBuilder.Field()
            fb.name = f.name
            if (i == table - 1)
                fb.value = f.value + "\n<@$x>"
            else {
                val v = f.value.split("\n").toMutableList()
                for ((j, l) in v.withIndex())
                    if (l.contains(x))
                        v[j] = "\n"
                fb.value = v.joinToString("\n")
            }

            fb.inline = true
            ebb.fields.add(fb)
        }
        return ebb
    }

}
